/*
 * This file was generated - do not edit it directly !!
 * Generated by AuDAO tool, a product of Spolecne s.r.o.
 * For more information please visit http://www.spoledge.com
 */
package com.spoledge.facicredit.db.dao.mysql;


import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.sql.Types;

import java.util.ArrayList;

import com.spoledge.audao.db.dao.AbstractDaoImpl;
import com.spoledge.audao.db.dao.DBException;
import com.spoledge.audao.db.dao.DaoException;


import com.spoledge.facicredit.db.dao.SeoWordDao;
import com.spoledge.facicredit.db.dto.SeoWord;


/**
 * This is the DAO imlementation class.
 *
 * @author generated
 */
public class SeoWordDaoImpl extends AbstractDaoImpl<SeoWord> implements SeoWordDao {

    private static final String TABLE_NAME = "seo_words";

    protected static final String SELECT_COLUMNS = "word_id, the_word";

    protected static final String PK_CONDITION = "word_id=?";

    private static final String SQL_INSERT = "INSERT INTO seo_words (the_word) VALUES (?)";

    public SeoWordDaoImpl( Connection conn ) {
        super( conn );
    }

    /**
     * Finds a record identified by its primary key.
     * @return the record found or null
     */
    public SeoWord findByPrimaryKey( int wordId ) {
        return findOne( PK_CONDITION, wordId);
    }

    /**
     * Finds a record.
     */
    public SeoWord findByTheWord( String theWord ) {
        return findOne( "the_word=?", theWord);
    }

    /**
     * Finds records.
     */
    public SeoWord[] findDynamic( String cond, int offset, int count, Object... params ) {
        return findManyArray( cond, offset, count, params);
    }

    /**
     * Inserts a new record.
     * @return the generated primary key - wordId
     */
    public int insert( SeoWord dto ) throws DaoException {
        PreparedStatement stmt = null;
        ResultSet rs = null;

        debugSql( SQL_INSERT, dto );

        try {
            stmt = conn.prepareStatement( SQL_INSERT, PreparedStatement.RETURN_GENERATED_KEYS );

            if ( dto.getTheWord() == null ) {
                throw new DaoException("Value of column 'the_word' cannot be null");
            }
            checkLength( "the_word", dto.getTheWord(), 3, 64 );
            stmt.setString( 1, dto.getTheWord() );

            int n = stmt.executeUpdate();

            rs = stmt.getGeneratedKeys();
            rs.next();

            dto.setWordId( rs.getInt( 1 ));

            return dto.getWordId();
        }
        catch (SQLException e) {
            errorSql( e, SQL_INSERT, dto );
            handleException( e );
            throw new DBException( e );
        }
        finally {
            if (rs != null) try { rs.close(); } catch (SQLException e) {}
            if (stmt != null) try { stmt.close(); } catch (SQLException e) {}
        }
    }

    /**
     * Returns the table name.
     */
    public String getTableName() {
        return TABLE_NAME;
    }

    protected String getSelectColumns() {
        return SELECT_COLUMNS;
    }

    protected SeoWord fetch( ResultSet rs ) throws SQLException {
        SeoWord dto = new SeoWord();
        dto.setWordId( rs.getInt( 1 ));
        dto.setTheWord( rs.getString( 2 ));

        return dto;
    }

    protected SeoWord[] toArray(ArrayList<SeoWord> list ) {
        SeoWord[] ret = new SeoWord[ list.size() ];
        return list.toArray( ret );
    }

}
