/*
 * This file was generated - do not edit it directly !!
 * Generated by AuDAO tool, a product of Spolecne s.r.o.
 * For more information please visit http://www.spoledge.com
 */
package com.spoledge.facicredit.db.dao.mysql;


import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.sql.Types;

import java.util.ArrayList;
import java.util.HashMap;

import com.spoledge.audao.db.dao.AbstractDaoImpl;
import com.spoledge.audao.db.dao.DBException;
import com.spoledge.audao.db.dao.DaoException;


import com.spoledge.facicredit.db.dao.SeoWordIndexDao;
import com.spoledge.facicredit.db.dto.SeoWordIndex;
import com.spoledge.facicredit.db.dto.Entity;


/**
 * This is the DAO imlementation class.
 *
 * @author generated
 */
public class SeoWordIndexDaoImpl extends AbstractDaoImpl<SeoWordIndex> implements SeoWordIndexDao {

    private static final String TABLE_NAME = "seo_word_index";

    protected static final String SELECT_COLUMNS = "word_id, entity_id, record_id, word_priority";

    protected static final String PK_CONDITION = "word_id=? and entity_id=? and record_id=?";

    private static final String SQL_INSERT = "INSERT INTO seo_word_index (word_id,entity_id,record_id,word_priority) VALUES (?,?,?,?)";
    private static final HashMap<Integer, Entity.EntityId> _Entity_EntityIds = new HashMap<Integer, Entity.EntityId>();

    static {
        _Entity_EntityIds.put( Entity.EntityId.SEGMENT.getId(), Entity.EntityId.SEGMENT);
        _Entity_EntityIds.put( Entity.EntityId.SEGMENT_RATING.getId(), Entity.EntityId.SEGMENT_RATING);
        _Entity_EntityIds.put( Entity.EntityId.SEGMENT_CONFIDENCE.getId(), Entity.EntityId.SEGMENT_CONFIDENCE);
        _Entity_EntityIds.put( Entity.EntityId.COMPANY_ACTIVITY_TYPE.getId(), Entity.EntityId.COMPANY_ACTIVITY_TYPE);
        _Entity_EntityIds.put( Entity.EntityId.PARTY.getId(), Entity.EntityId.PARTY);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_ICO.getId(), Entity.EntityId.PARTY_ICO);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_NAME.getId(), Entity.EntityId.PARTY_NAME);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_ADDRESS.getId(), Entity.EntityId.PARTY_ADDRESS);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_PHONE.getId(), Entity.EntityId.PARTY_PHONE);
        _Entity_EntityIds.put( Entity.EntityId.PAYMENT_RATING.getId(), Entity.EntityId.PAYMENT_RATING);
        _Entity_EntityIds.put( Entity.EntityId.FINANCIAL_STATE.getId(), Entity.EntityId.FINANCIAL_STATE);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_RATING.getId(), Entity.EntityId.PARTY_RATING);
        _Entity_EntityIds.put( Entity.EntityId.USER_COMMENT.getId(), Entity.EntityId.USER_COMMENT);
        _Entity_EntityIds.put( Entity.EntityId.BATCH.getId(), Entity.EntityId.BATCH);
        _Entity_EntityIds.put( Entity.EntityId.LOG_HISTORY.getId(), Entity.EntityId.LOG_HISTORY);
        _Entity_EntityIds.put( Entity.EntityId.USER.getId(), Entity.EntityId.USER);
        _Entity_EntityIds.put( Entity.EntityId.ROLE.getId(), Entity.EntityId.ROLE);
        _Entity_EntityIds.put( Entity.EntityId.USER_ROLE.getId(), Entity.EntityId.USER_ROLE);
        _Entity_EntityIds.put( Entity.EntityId.APPSEC_MODULE.getId(), Entity.EntityId.APPSEC_MODULE);
        _Entity_EntityIds.put( Entity.EntityId.APPSEC_ACTION.getId(), Entity.EntityId.APPSEC_ACTION);
        _Entity_EntityIds.put( Entity.EntityId.APPSEC_ACCESS.getId(), Entity.EntityId.APPSEC_ACCESS);
    }

    public SeoWordIndexDaoImpl( Connection conn ) {
        super( conn );
    }

    /**
     * Finds a record identified by its primary key.
     * @return the record found or null
     */
    public SeoWordIndex findByPrimaryKey( int wordId, Entity.EntityId entityId, int recordId ) {
        return findOne( PK_CONDITION, wordId, entityId.getId(), recordId);
    }

    /**
     * Finds records.
     */
    public SeoWordIndex[] findByWordIdEntityId( int wordId, Entity.EntityId entityId ) {
        return findManyArray( "word_id=? and entity_id=?", 0, -1, wordId, entityId.getId());
    }

    /**
     * Finds records.
     */
    public SeoWordIndex[] findByWordId( int wordId ) {
        return findManyArray( "word_id=?", 0, -1, wordId);
    }

    /**
     * Finds records.
     */
    public SeoWordIndex[] findByEntityIdRecordId( Entity.EntityId entityId, int recordId ) {
        return findManyArray( "entity_id=? and record_id=?", 0, -1, entityId.getId(), recordId);
    }

    /**
     * Finds records.
     */
    public SeoWordIndex[] findByEntityId( Entity.EntityId entityId ) {
        return findManyArray( "entity_id=?", 0, -1, entityId.getId());
    }

    /**
     * Deletes records using index inx_seo_winx_rec.
     * @return the number of records deleted
     */
    public int deleteByEntityIdRecordId( Entity.EntityId entityId, int recordId ) throws DaoException {
        return deleteMany( "entity_id=? and record_id=?", entityId.getId(), recordId);
    }

    /**
     * Inserts a new record.
     */
    public void insert( SeoWordIndex dto ) throws DaoException {
        PreparedStatement stmt = null;

        debugSql( SQL_INSERT, dto );

        try {
            stmt = conn.prepareStatement( SQL_INSERT );

            if ( dto.getWordId() == null ) {
                throw new DaoException("Value of column 'word_id' cannot be null");
            }
            stmt.setInt( 1, dto.getWordId() );

            if ( dto.getEntityId() == null ) {
                throw new DaoException("Value of column 'entity_id' cannot be null");
            }
            stmt.setInt( 2, dto.getEntityId().getId() );

            if ( dto.getRecordId() == null ) {
                throw new DaoException("Value of column 'record_id' cannot be null");
            }
            stmt.setInt( 3, dto.getRecordId() );

            if ( dto.getWordPriority() == null ) {
                throw new DaoException("Value of column 'word_priority' cannot be null");
            }
            stmt.setInt( 4, dto.getWordPriority() );

            int n = stmt.executeUpdate();
        }
        catch (SQLException e) {
            errorSql( e, SQL_INSERT, dto );
            handleException( e );
            throw new DBException( e );
        }
        finally {
            if (stmt != null) try { stmt.close(); } catch (SQLException e) {}
        }
    }

    /**
     * Returns the table name.
     */
    public String getTableName() {
        return TABLE_NAME;
    }

    protected String getSelectColumns() {
        return SELECT_COLUMNS;
    }

    protected SeoWordIndex fetch( ResultSet rs ) throws SQLException {
        SeoWordIndex dto = new SeoWordIndex();
        dto.setWordId( rs.getInt( 1 ));
        dto.setEntityId( _Entity_EntityIds.get( rs.getInt( 2 )));
        dto.setRecordId( rs.getInt( 3 ));
        dto.setWordPriority( rs.getInt( 4 ));

        return dto;
    }

    protected SeoWordIndex[] toArray(ArrayList<SeoWordIndex> list ) {
        SeoWordIndex[] ret = new SeoWordIndex[ list.size() ];
        return list.toArray( ret );
    }

}
